#!/usr/bin/env python
# -*- encoding : ascii -*-
#
# Threading processing class of Clonezilla GUI
#
# Copyright (c) 2010~ Zong-shuo Jheng <c00aso00 at nchc org tw>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.


import pygtk
pygtk.require('2.0')
import os, sys
import string, datetime
import gtk, gobject
import locale, gettext
import threading
import time

import commands



class WorkerThread(threading.Thread):
    def __init__(self, parent, cmd):
        threading.Thread.__init__(self)
        self.parent = parent
        self.cmd = cmd
        #self.total = 0

    def run(self):
        self.work_complete = False
        self.amount_completed = 0
        gobject.timeout_add(100, self._update_bar)

        count = 0
        run_cmd = "yes | LANG=en.US "
        run_cmd += self.cmd
        run_cmd += " 2> /tmp/partclone_processbar.log&"

        print run_cmd
        p = subprocess.Popen(run_cmd, shell=True, stdin=subprocess.PIPE,stdout=subprocess.PIPE,stderr=subprocess.PIPE)

        text = p.stdout.readline()
        while text:
            if string.find(text, "***") == -1:
                self.parent.msg_log.set_text(text)
            print text
            text = p.stdout.readline()

        p.wait()
        self.work_complete = True
        self.parent.msg_log.set_text("Job done......")
        self.parent.parent.go_forward_btn.clicked()

    def _update_bar(self):
        if os.path.exists("/tmp/partclone_processbar.log"):
            p = subprocess.Popen("tail -n 1 /tmp/partclone_processbar.log&", shell=True, stdin=subprocess.PIPE,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
            text = p.communicate()[0]
            textPattern = re.compile("Completed:\s+(?P<percent>[0-9]+\.[0-9]+\%)")
            #Elapsed: 00:01:31, Remaining: 00:00:14, Completed: 86.29%, Rate: 859.06MB/min,
            for t in re.findall(textPattern, text):
                s = t.split('%')[0]
                i = float(s)/100
                self.parent.progressbar.set_fraction(i)
                self.parent.progressbar.set_text("%s%%" %s)

            if text.find('successful') != -1:
                self.parent.progressbar.set_fraction(1.0)
                self.parent.progressbar.set_text("100%")

        return not self.work_complete

